<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAbsence ArrayType
 * @subpackage Arrays
 */
class ArrayOfAbsence extends AbstractStructArrayBase
{
    /**
     * The Absence
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Absence[]
     */
    public $Absence;
    /**
     * Constructor method for ArrayOfAbsence
     * @uses ArrayOfAbsence::setAbsence()
     * @param \StructType\Absence[] $absence
     */
    public function __construct(array $absence = array())
    {
        $this
            ->setAbsence($absence);
    }
    /**
     * Get Absence value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Absence[]|null
     */
    public function getAbsence()
    {
        return isset($this->Absence) ? $this->Absence : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAbsence method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAbsence method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAbsenceForArrayConstraintsFromSetAbsence(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAbsenceAbsenceItem) {
            // validation for constraint: itemType
            if (!$arrayOfAbsenceAbsenceItem instanceof \StructType\Absence) {
                $invalidValues[] = is_object($arrayOfAbsenceAbsenceItem) ? get_class($arrayOfAbsenceAbsenceItem) : sprintf('%s(%s)', gettype($arrayOfAbsenceAbsenceItem), var_export($arrayOfAbsenceAbsenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Absence property can only contain items of type \StructType\Absence, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Absence value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Absence[] $absence
     * @return \ArrayType\ArrayOfAbsence
     */
    public function setAbsence(array $absence = array())
    {
        // validation for constraint: array
        if ('' !== ($absenceArrayErrorMessage = self::validateAbsenceForArrayConstraintsFromSetAbsence($absence))) {
            throw new \InvalidArgumentException($absenceArrayErrorMessage, __LINE__);
        }
        if (is_null($absence) || (is_array($absence) && empty($absence))) {
            unset($this->Absence);
        } else {
            $this->Absence = $absence;
        }
        return $this;
    }
    /**
     * Add item to Absence value
     * @throws \InvalidArgumentException
     * @param \StructType\Absence $item
     * @return \ArrayType\ArrayOfAbsence
     */
    public function addToAbsence(\StructType\Absence $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Absence) {
            throw new \InvalidArgumentException(sprintf('The Absence property can only contain items of type \StructType\Absence, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Absence[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Absence|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Absence|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Absence|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Absence|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Absence|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Absence
     */
    public function getAttributeName()
    {
        return 'Absence';
    }
}
